#include <stdio.h>
#include <omp.h>
int main() {
  int nthreads;
  printf("At start of program\n");
  #pragma omp parallel default(none) shared(nthreads)
  {
    int mythread = omp_get_thread_num();
    if (mythread==0)
      nthreads = omp_get_num_threads();
    printf("Hello world from thread %d!\n",
           omp_get_thread_num());
  }
  printf("There were %d threads.\n", nthreads);
  return 0;
}


